<?php
/**
 * Integrates FireBoard forum structure into Xmap tree in a proper way with valid links.
 * @author Mr. Ayan Debnath, INDIA.
 * @email ayan_don@hotmail.com (Please don't SPAM me)
 * @version 1.1
 */

// Register with the Xmap Plugin Manager
$tmp = new Xmap_fireboard;
XmapPlugins::addPlugin($tmp );

/** Handles FireBoard forum structure */
class Xmap_fireboard
{
   /** Check if we are responsible for this kind of content */
   function isOfType( &$joomla, &$parent )
   {
      if( ( $parent->type === 'component' || $parent->type === 'components' ) &&  strpos($parent->link, 'option=com_fireboard'))      {
		return true;
      }
      return false;
   }

/* Return category/forum tree */
function &getTree( &$xmap, &$parent, $parentCat=0 ) 
{
  global $database,$my;
  $list = array();
  # $query = "SELECT id as cat_id, name as cat_title, ordering FROM #__fb_categories WHERE parent>0 AND published=1 ORDER BY name";
  $query = "SELECT id as cat_id, name as cat_title, ordering FROM #__fb_categories WHERE parent=$parentCat AND published=1 and pub_access<=".$my->gid." ORDER BY name";
  $database->setQuery($query);
  $cats = $database->loadObjectList();									
  
  /*get list of categories*/
  foreach($cats as $cat) 
  {
    $node = new stdclass;
    $node->id   = $parent->id;
    $node->name = $cat->cat_title;
    $node->link = $parent->link.'&amp;func=showcat&amp;catid='.$cat->cat_id;
    $node->tree = $this->getTree($xmap,$parent,$cat->cat_id);
    $list[$cat->cat_id] = $node;
  }
  
/* You can change the format by changing the SQL statement below */
  $querymsg = "SELECT id as forum_id, catid as cat_id, subject as forum_name, time as modified"." FROM #__fb_messages WHERE catid=$parentCat and subject NOT LIKE 'Re:%' ORDER BY ordering ";

  $database->setQuery($querymsg);
  $forums = $database->loadObjectList();

  //get list of forums
  foreach($forums as $forum) {

    // sort forums into categories
    if( !isset($list[$forum->cat_id]) ) continue;

    $node = new stdclass;
    $node->id = $parent->id;
    $node->name = $forum->forum_name;
    $node->modified = intval($forum->modified);
    $node->link = $parent->link.'&amp;func=view&amp;id='.$forum->forum_id.'&amp;catid='.$forum->cat_id;
    $list[$forum->cat_id]->tree[] = $node;
  }
  return $list;
}
} 
